/*
 * Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
 * smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
 * Restrictions in GB_copyright.h.
 *
 *  toggle.c -- toggles some options
 */

#include "GB_copyright.h"
#define EXTERN extern
#include "vars.h"
#include "races.h"
#include "buffers.h"
#include <strings.h>
int toggle_racedata;

toggle(Playernum,APcount, argn, args)
int Playernum;
int APcount;
int argn;
char args[MAXARGS][COMMANDSIZE];
{
int i;


   if (argn>1) {
	i = strlen(args[1]);
	free(Race);
	openracedata(&toggle_racedata);
	getrace(toggle_racedata, &Race, Playernum);
	close_file(toggle_racedata);

	if (!strncmp(args[1],"inverse",i)) tog(Playernum,&Race->inverse,"inverse");
	else if (!strncmp(args[1],"double_digits",i)) tog(Playernum,&Race->double_digits,
				"double_digits");
	else if (!strncmp(args[1],"geography",i)) tog(Playernum,&Race->geography,"geography");
	else if (!strncmp(args[1],"autoload",i)) tog(Playernum,&Race->autoload,"autoload");
	else {
		sprintf(buf,"No such option '%s'\n", args[1]);
			notify(Playernum, buf);
		}
openracedata(&toggle_racedata);
putrace(toggle_racedata, Race);
close_file(toggle_racedata);

   } else {
	sprintf(buf,"inverse is %s\n", Race->inverse ? "ON" : "OFF");
			notify(Playernum, buf);
	sprintf(buf,"double_digits is %s\n", Race->double_digits ? "ON" : "OFF");
			notify(Playernum, buf);
	sprintf(buf,"geography is %s\n", Race->geography ? "ON" : "OFF");
			notify(Playernum, buf);
	sprintf(buf,"autoload is %s\n", Race->autoload ? "ON": "OFF");
			notify(Playernum, buf);
   }

}


tog(Playernum,op, name)
int Playernum;
int *op;
char *name;
{
 *op = !(*op);
 sprintf(buf, "%s is now %s\n", name, *op ? "on" : "off" );
			notify(Playernum, buf);
}

